<template>
  <div class="text-titulo q-pa-xs">
    <q-icon name="cake" /> Cumpleaños Cercanos
  </div>
  <q-card>
    <!--- bordered-->
    <q-list dense bordered separator>
      <q-item clickable v-ripple v-for="persona in dataSet" :key="persona.uuid">
        <q-item-section class="lt-lg">
          <PersonaDetalle :persona="persona" />
          <PersonasFunciones :funciones="persona.funciones" />
        </q-item-section>

        <q-item-section class="gt-md">
          <PersonaDetalle :persona="persona" />
        </q-item-section>

        <q-item-section class="gt-md">
          <PersonasFunciones :funciones="persona.funciones" />
        </q-item-section>

        <q-item-section side>
          <q-item-label caption lines="1">
            <span>Fecha :</span>{{ persona.cumpleanios }}
          </q-item-label>
          <q-item-label caption lines="2">
            <span>Años :</span>{{ persona.cumple }}
          </q-item-label>
        </q-item-section>
      </q-item>

      <q-markup-table v-if="loading">
        <tbody>
          <tr v-for="n in 5" :key="n">
            <td class="text-left">
              <q-skeleton animation="blink" type="text" width="85px" />
            </td>
            <td class="text-right">
              <q-skeleton animation="blink" type="text" width="50px" />
            </td>
            <td class="text-right">
              <q-skeleton animation="blink" type="text" width="35px" />
            </td>
          </tr>
        </tbody>
      </q-markup-table>
    </q-list>
  </q-card>
</template>

<script lang="ts">
import { defineComponent, ref, onMounted } from 'vue';
import { api } from 'src/boot/axios/index';
import { AxiosResponse } from 'axios';
import { PersonaCumpleAniosInterface } from 'src/interfaces/PersonasInterface';
import PersonaDetalle from 'components/Personas/Detalle.vue';
import PersonasFunciones from 'components/Personas/Funciones.vue';

export default defineComponent({
  name: 'IndexPage',
  components: { PersonaDetalle, PersonasFunciones },
  setup() {
    const loading = ref(true);

    onMounted(() => {
      getCumpleanios();
    });

    const dataSet = ref<PersonaCumpleAniosInterface[]>();
    function getCumpleanios() {
      api
        .get('/api/persona/personas/cumpleanios')
        .then((response: AxiosResponse) => {
          dataSet.value = response.data.data;
        })
        .finally(() => {
          loading.value = false;
        });
    }

    return { loading, dataSet };
  },
});
</script>
